import logging
import signal
import socket
import sys
import time

def exit_server(signal, frame):
    global server
    print('Detected CTRL-C, exiting ...', file=sys.stderr)

    if not server is None:
        logging.debug('Closing server socket')
        server.close()

    logging.debug('Server exiting ...')
    sys.exit(0)
    
def main():
    global server
    signal.signal(signal.SIGINT, exit_server)

    host = '0.0.0.0'
    port = 50001
    bufsize = 1024
    
    logfile = 'helloserver.log'
    loglevel = logging.DEBUG
    logging.basicConfig(filename=logfile,level=loglevel)
    
    server =  socket.socket(family=socket.AF_INET, \
            type=socket.SOCK_STREAM, proto=0, fileno=None)
    server.bind((host, port))
    logging.debug('Binds the server to host ' + host  + ' at port ' + str(port))
    server.listen(); 
    logging.debug('Server is listening to incoming connection')
    while True:
        (conn, caddr) = server.accept()
        logging.debug('Server accepts a connection from ' + str(caddr))

        msg = 'What\'s up?'
        buf = msg.encode()
        conn.send(buf)

        buf = conn.recv(bufsize)
        msg = buf.decode()
        logging.debug('Received \'' + msg + '\'')
        print('Client says: ' + msg )

        logging.debug('Closing client connection')
        conn.close()

if __name__ == "__main__":
    main()
